VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cFuncCall"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Enum DECLSPEC
  eStdCall
  eCDecl
End Enum

'***********************************************
'* This module use excelent solution from
'* http://www.vbdotcom.com/FreeCode.htm
'* how to implement assembly calls directly
'* into VB code.
'***********************************************

' ,      ...
'    ...
'    ...
'   , !

Private Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Private Declare Function GetProcAddress Lib "kernel32" (ByVal HMODULE As Long, ByVal lpProcName As String) As Long
Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Private Declare Function PutMem2 Lib "msvbvm60" (ByVal pWORDDst As Long, ByVal NewValue As Long) As Long
Private Declare Function PutMem4 Lib "msvbvm60" (ByVal pDWORDDst As Long, ByVal NewValue As Long) As Long
Private Declare Function GetMem4 Lib "msvbvm60" (ByVal pDWORDSrc As Long, ByVal pDWORDDst As Long) As Long
Private Declare Function GlobalAlloc Lib "kernel32" (ByVal wFlags As Long, ByVal dwBytes As Long) As Long
Private Declare Function GlobalFree Lib "kernel32" (ByVal hMem As Long) As Long

Private Const GMEM_FIXED As Long = &H0

Private m_hLib As Long
Private m_CallType As DECLSPEC

Private Const asmPUSH_imm32 As Byte = &H68
Private Const asmRET_imm16 As Byte = &HC2
Private Const asmCALL_rel32 As Byte = &HE8

Public Property Let LibraryName(NameOrHMODULE As Variant)
  Select Case VarType(NameOrHMODULE)
  Case vbString
    If m_hLib Then FreeLibrary m_hLib
    m_hLib = LoadLibrary(CStr(NameOrHMODULE))
  Case vbLong, vbInteger
    If m_hLib Then FreeLibrary m_hLib
    m_hLib = CLng(NameOrHMODULE)
  Case Else
    Err.Raise 5
  End Select
  
  If m_hLib = 0 Then Err.Raise 48
End Property

Public Property Let CallType(ByVal lData As DECLSPEC)
  m_CallType = lData
End Property

Public Function GetPointer(ByVal FuncName As String) As Long
  GetPointer = GetProcAddress(m_hLib, FuncName)
End Function

Public Function CallFunction(ByVal FuncName As String, ByRef FuncPointer As Long, ByVal ParamsCount As Long, Optional ByVal p1 As Long = 0, Optional ByVal p2 As Long = 0, Optional ByVal p3 As Long = 0, Optional ByVal p4 As Long = 0, Optional ByVal p5 As Long = 0, Optional ByVal p6 As Long = 0, Optional ByVal p7 As Long = 0, Optional ByVal p8 As Long = 0, Optional ByVal p9 As Long = 0, Optional ByVal p10 As Long = 0) As Long
  
  ' :
  '   -  FuncPointer = 0,    FuncName,  
  '     FuncPointer     .
  '   -  FuncPointer <> 0,      FuncPointer,
  '      FuncName .
  
  Dim i As Long, t As Long
  Dim hGlobal As Long, hGlobalOffset As Long
  
  If ParamsCount < 0 Then Err.Raise 5 'invalid call
  
  If FuncPointer = 0 Then
    FuncPointer = GetProcAddress(m_hLib, FuncName)
    If FuncPointer = 0 Then Err.Raise 453 'function not found
  End If
  
  ' :  GlobalAlloc    dword-aligned  
  '5        
  '5  -    
  '3  -    cdecl
  '3  - ret 0x0010,      CallWindowProc
  '1  - ,   PutMem4  4 .
  
  hGlobal = GlobalAlloc(GMEM_FIXED, 5 * ParamsCount + 5 + 3 + 3 + 1) '  , ZEROINIT  .
  If hGlobal = 0 Then Err.Raise 7 'insuff. memory
  hGlobalOffset = hGlobal
  
  ' :      byval long ...
  '   ,      varptr?
  '    , --?
  
  If ParamsCount > 0 Then
    t = VarPtr(p1)
    For i = ParamsCount - 1 To 0 Step -1
      PutMem2 hGlobalOffset, asmPUSH_imm32
      hGlobalOffset = hGlobalOffset + 1
      GetMem4 t + i * 4, hGlobalOffset  '    :)
      hGlobalOffset = hGlobalOffset + 4
    Next
  End If
  
  '  
  PutMem2 hGlobalOffset, asmCALL_rel32
  hGlobalOffset = hGlobalOffset + 1
  PutMem4 hGlobalOffset, FuncPointer - hGlobalOffset - 4
  hGlobalOffset = hGlobalOffset + 4
  
  If m_CallType = eCDecl Then
    PutMem2 hGlobalOffset, &HC483          'add esp, imm8
    hGlobalOffset = hGlobalOffset + 2
    PutMem2 hGlobalOffset, ParamsCount * 4 ' imm8
    hGlobalOffset = hGlobalOffset + 1
  End If
  
  PutMem4 hGlobalOffset, &H10C2&        'ret 0x0010
  
  CallFunction = CallWindowProc(hGlobal, 0, 0, 0, 0)
  
  GlobalFree hGlobal
End Function

Private Sub Class_Initialize()
  m_CallType = eStdCall
End Sub

Private Sub Class_Terminate()
  If m_hLib Then FreeLibrary m_hLib
End Sub
